/* ESERCIZIO (3 di AltriEsercizi5 del 9-5-2017)
(a)
 Definire una classe per oggetti che forniscano valori Non-Modificabili 
 da utilizzare in modo simile ai valori stack bounded di int introdotti 
 da InstStack in Lezione10. La classe deve fornire un'implementazione 
 dei valori stack (che utilizzi un array p e una coppia di interi n e 
 top) e delle operazioni push, top, pop, empty. Non è richiesto che la 
 classe definisca anche un tipo astratto. Si suggerisce anzi, di utiliz-
 zare solo definizioni con modificatore "public". 
 SOLUZIONE (a)
 */

import java.util.*;
import java.lang.*;

class Error extends RuntimeException{
}

public class StackImm{
	public int[] p;
	public int n;
	public int top;	
	//metodi
	public StackImm(){//synonym of create for introducing empty stacks
		p = new int[100];
		n = 0;
		top = -1;
	}
	public StackImm push(int k){
		if (n==100) throw new Error();
		StackImm ret = new StackImm();
		for (int i=0;i<n;i++)ret.p[i]=p[i];
		ret.p[n]=k;
		ret.n = n+1; ret.top = top+1;
		return ret;
	}
	public int top(){
        if(n==0) throw new Error();
		return p[top];
	}
	public StackImm pop(){
		if (n==0) throw new Error();
		StackImm ret = new StackImm();
		for (int i=0;i<n-1;i++)ret.p[i] = p[i];
		ret.n = n-1; ret.top = top-1;
		
		return this;
	}
	public boolean empty(){		
		return (n==0); 
	}
}

/*
 (b) 
 Si compili la classe completata
 SOLUZIONE (b)
 
 Marco-Bellias-MacBook-Pro-2:Stack marcob$ ls
 StackImm.java	StackImm2.java	StackMut.java	code
 Marco-Bellias-MacBook-Pro-2:Stack marcob$ javac StackImm.java -d code
*/


/*
 (c)
 Si definisca e si compili una nuova classe Main che usa gli oggetti StackImm: 
 In particolare, associa ad una variabile stack1 lo stack [1;5] e alla variabi-
 le stack2 lo stack [1;5;12].
 SOLUZIONE (c) 
*/ 
 
 
class Main{
    public static void main(String[] args) throws Error{
        StackImm stack1 = new StackImm().push(1).push(5);
		StackImm stack2 = stack1.push(12);
        System.out.println("stack1.top = " + stack1.top());
		System.out.println("stack2.top = " + stack2.top());    
	}
}	

/*
 Marco-Bellias-MacBook-Pro-2:stack marcob$ javac StackImm.java -d code
 Marco-Bellias-MacBook-Pro-2:stack marcob$ cd code;ls
 Error.class	Main.class	StackImm.class
 Marco-Bellias-MacBook-Pro-2:code marcob$ java Main
 stack1.top = 5
 stack2.top = 12
 Marco-Bellias-MacBook-Pro-2:code marcob$ 
*/ 


 
 
