/* ESERCIZIO (4 di AltriEsercizi5 del 9-5-2017)
 (a)
 Definire una classe per oggetti che forniscano valori Non-Modificabili 
 da utilizzare in modo simile ai valori stack bounded di int introdotti 
 da InstStack in Lezione10. La classe deve fornire un'implementazione 
 dei valori stack e delle operazioni push, top, pop, empty. Non è richie-
 sto che la classe definisca anche un tipo astratto. Si suggerisce anzi, 
 di utilizzare solo definizioni con modificatore "public". 
 SOLUZIONE (a)
 */

import java.util.*;
import java.lang.*;

class Error extends RuntimeException{
}
public class StackImm2{
	public Vector<Integer> p;
	//metodi
	public StackImm2(){//synonym of create for introducing empty stacks
        p = new Vector<Integer>(); 
	}
	public StackImm2 push(int k){
		if (p.size()==100) throw new Error();
		StackImm2 ret = new StackImm2();
		for (int i=0;i<p.size();i++)ret.p.add(p.get(i));
		ret.p.add(k);
		return ret;
	}
	public int top(){
		if(p.size()==0)throw new Error();
		return p.get(p.size()-1);
	}
	public StackImm2 pop(){		
		if (p.size()==0) throw new Error();
		StackImm2 ret = new StackImm2();
		for (int i=0;i<p.size()-1;i++)ret.p.add(p.get(i));
		return ret;
	}
	public boolean empty(){		
		return (p.size()==0); 
	}
}

/*
 (b)
 Si definisca e si compili una nuova classe Main che usa gli oggetti StackImm: 
 In particolare, associa ad una variabile stack1 lo stack [1;5] e alla variabi-
 le stack2 lo stack [1;5;12].
 SOLUZIONE (b) 
*/ 


class Main{
    public static void main(String[] args) throws Error{
        StackImm2 stack1 = new StackImm2().push(1).push(5);
		StackImm2 stack2 = stack1.push(12);
        System.out.println("stack1.top = " + stack1.top());
		System.out.println("stack2.top = " + stack2.top());    
	}
}	

/*
 Marco-Bellias-MacBook-Pro-2:stack marcob$ javac StackImm2.java -d code2
 Marco-Bellias-MacBook-Pro-2:stack marcob$ cd code2
 Marco-Bellias-MacBook-Pro-2:code2 marcob$ ls
 Error.class	Main.class	StackImm2.class
 Marco-Bellias-MacBook-Pro-2:code2 marcob$ java Main
 stack1.top = 5
 stack2.top = 12
 Marco-Bellias-MacBook-Pro-2:code2 marcob$ 
*/ 

/*
 (c)
 Si forniscano le funzioni AF ed I per la nuova rappresentazione.
 SOLUZIONE (c)
 
 Assunto che un valore stack abbia forma [v1;...;vk], con vk ultimo inserito 
 e top dello stack, quando k>0. Mentre abbia forma [] per lo stack vuoto.
 Funzione AF:
 AF(c) = [] se c.p.size()==0
 AF(c) = [v1;...;vk] con vi = c.p.get(i-1) per 1<=i<=k, and k==c.p.size()
 Invariante I:
 c.p!=null;
 
 (d)
 Sotto quali condizioni I e' soddisfatto in un programma contenente la classe 
 StackImm2.java
 SOLUZIONE (c)
 
 Sia P un programma che contiene la classe StackImm2. Allora I e' soddisfatto in
 P se P non contiene alcun costrutto E.p = null nelle sue classi, dove E sia una
 qualunque espressione (qualificatore) di tipo StackImm. 
 Diventa se e solo se allorche' possiamo considerare tutti i costrutti diversi che
 conducono ad una modifica equivalente a E.p = null.
*/

