 /* ESERCIZIO
 (a)
 Definire interfaccia APISTKImm di un stack di interi bounded 100 IMMUTABLE.
 (b)
 Dare una classe StackImm2ADT che fornisca una versione ADT di StackImm2 per APISTKImm
 (c)
 Utilizzare la classe per verificare che i programmi "cheating" non sono più possibili

 SOLUZIONE (a)
 */

import java.util.*;
import java.lang.*;

class Error extends RuntimeException{
}

interface APISTKImm{
    public APISTKImm push(int k);
    public int top();
    public APISTKImm pop();
    public boolean empty();
}


public class StackImm2ADT implements APISTKImm{
	private Vector<Integer> p;
	//metodi
	public StackImm2ADT(){//synonym of create for introducing empty stacks
		p = new Vector<Integer>();
	}
	public StackImm2ADT push(int k){
		if (p.size()==100) throw new Error();
		StackImm2ADT ret = new StackImm2ADT();
		for (int i=0;i<p.size()-1;i++)ret.p.add(p.get(i));
		ret.p.add(k);
		return ret;
	}
	public int top(){
		if(p.size()==0)throw new Error();
		return p.get(p.size()-1);
	}
	public StackImm2ADT pop(){
		if (p.size()==0) throw new Error();
		StackImm2ADT ret = new StackImm2ADT();
		for (int i=0;i<p.size()-2;i++)ret.p.add(p.get(i));
		return ret;
	}
	public boolean empty(){		
		return (p.size()==0); 
	}
}

/*
 (d)
 Si definisca e si compili una nuova classe Main che usa gli oggetti StackImm: 
 In particolare, associa ad una variabile stack1 lo stack [1;5] e alla variabi-
 le stack2 lo stack [1;5;12].
 SOLUZIONE (d
)
*/ 


class Main{
    public static void main(String[] args) throws Error{
        StackImm2ADT stack1 = new StackImm2ADT().push(1).push(5);
		StackImm2ADT stack2 = stack1.push(12);
        System.out.println("stack1.top = " + stack1.top());
		System.out.println("stack2.top = " + stack2.top());    
	}
}

/*
host-131-114-252-220:Stack marcob$ javac StackImm2ADT.java -d Zcode2bis/
host-131-114-252-220:Stack marcob$ cd Zcode2bis/
host-131-114-252-220:Zcode2bis marcob$ java Main
stack1.top = 5
stack2.top = 12
host-131-114-252-220:Zcode2bis marcob$
*/

