 /* ESERCIZIO
 (a)
 Definire interfaccia APISTKImmPoly di un stack polimorfo bounded 100 IMMUTABLE.
 (b)
 Dare una classe StackImm2ADTP che fornisca una versione ADT di StackImm2 per APISTKImmPoly
 (c)
  Si definisca e si compili una nuova classe Main che usa gli oggetti StackImm2ADTP:
  In particolare, associa ad una variabile stack1 lo stack [1;5] e alla variabi-
  le stack2 lo stack [1;5;12].

 SOLUZIONE (a)
 */

import java.util.*;
import java.lang.*;

class Error extends RuntimeException{
}

interface APISTKImmPoly<A>{
    public APISTKImmPoly<A> push(A k);
    public A top();
    public APISTKImmPoly<A> pop();
    public boolean empty();
}


public class StackImm2ADTP<A> implements APISTKImmPoly<A>{
	private Vector<A> p;
	//metodi
	public StackImm2ADTP(){//synonym of create for introducing empty stacks
		p = new Vector<A>();
	}
	public StackImm2ADTP<A> push(A k){
		if (p.size()==100) throw new Error();
		StackImm2ADTP<A> ret = new StackImm2ADTP<A>();
		for (int i=0;i<p.size();i++)ret.p.add(p.get(i));
		ret.p.add(k);
		return ret;
	}
	public A top(){
		if(p.size()==0)throw new Error();
		return p.get(p.size()-1);
	}
	public StackImm2ADTP<A> pop(){
		if (p.size()==0) throw new Error();
		StackImm2ADTP<A> ret = new StackImm2ADTP<A>();
		for (int i=0;i<p.size()-1;i++)ret.p.add(p.get(i));
		return ret;
	}
	public boolean empty(){		
		return (p.size()==0); 
	}
}

/*
 (c)
 Si definisca e si compili una nuova classe Main che usa gli oggetti StackImm: 
 In particolare, associa ad una variabile stack1 lo stack [1;5] e alla variabi-
 le stack2 lo stack [1;5;12].
 SOLUZIONE (c)
)
*/ 


class Main{
    public static void main(String[] args) throws Error{
        StackImm2ADTP<Integer> stack1 =
                        new StackImm2ADTP<Integer>().push(1).push(5);
		StackImm2ADTP<Integer> stack2 = stack1.push(12);
        System.out.println("stack1.top = " + stack1.top());
		System.out.println("stack2.top = " + stack2.top());    
	}
}

/*
host-131-114-252-220:Stack marcob$ javac StackImm2ADT.java -d Zcode2bis/
host-131-114-252-220:Stack marcob$ cd Zcode2bis/
host-131-114-252-220:Zcode2bis marcob$ java Main
stack1.top = 5
stack2.top = 12
host-131-114-252-220:Zcode2bis marcob$
*/

