  /* ESERCIZIO
 (a)
 Definire interfaccia APISTKImmPoly di un stack polimorfo bounded 100 IMMUTABLE.
 (b)
 Dare una classe StackImm2ADTP che fornisca una versione ADT di StackImm2 per APISTKImmPoly
 con additional equals
 (c)
  Si definisca e si compili una nuova classe Main che usa gli oggetti StackImm2ADTP:
  In particolare, associa ad una variabile stack1 lo stack [1;5] e alla variabi-
  le stack2 lo stack [1;5;12].

 SOLUZIONE (a)
 */

import java.util.*;
import java.lang.*;

class Error extends RuntimeException{
}

interface APISTKImmPoly<A>{
    public APISTKImmPoly<A> push(A k);
    public A top();
    public APISTKImmPoly<A> pop();
    public boolean empty();
}


public class StackImm2ADTPE<A> implements APISTKImmPoly<A>{
	private Vector<A> p;
	//metodi
	public StackImm2ADTPE(){//synonym of create for introducing empty stacks
		p = new Vector<A>();
	}
	public StackImm2ADTPE<A> push(A k){
		if (p.size()==100) throw new Error();
		StackImm2ADTPE<A> ret = new StackImm2ADTPE<A>();
		for (int i=0;i<p.size();i++)ret.p.add(p.get(i));
		ret.p.add(k);
		return ret;
	}
	public A top(){
		if(p.size()==0)throw new Error();
		return p.get(p.size()-1);
	}
	public StackImm2ADTPE<A> pop(){
		if (p.size()==0) throw new Error();
		StackImm2ADTPE<A> ret = new StackImm2ADTPE<A>();
		for (int i=0;i<p.size()-1;i++)ret.p.add(p.get(i));
		return ret;
	}
	public boolean empty(){		
		return (p.size()==0); 
	}
//additionals
	public boolean equals(Object o){
		StackImm2ADTPE<?> ok;
		try {ok = (StackImm2ADTPE<?>)o;}
		catch (Exception e) {return false;}
		if (p.size()!=ok.p.size()) return false;
		for (int i=0;i<p.size()-1;i++){
			if (!(p.get(i).equals(ok.p.get(i))))
			return false;
		}
		return true;
	}
}
/*
 (c)
 Si definisca e si compili una nuova classe Main che usa gli oggetti StackImm: 
 In particolare, associa ad una variabile stack1 lo stack [1;5] e alla variabi-
 le stack2 lo stack [1;5;12].
 SOLUZIONE (c)
)
*/ 


class Main{
    public static void main(String[] args) throws Error{
        StackImm2ADTPE<Integer> stack1 =
                        new StackImm2ADTPE<Integer>().push(1).push(5);
		StackImm2ADTPE<Integer> stack2 = stack1.push(12);
        System.out.println("stack1.top = " + stack1.top());
		System.out.println("stack2.top = " + stack2.top());
		StackImm2ADTPE<Integer> stack3 = 
				new StackImm2ADTPE<Integer>().push(1).push(5).push(12);
		System.out.println("stack2 == stack3 vale " + (stack2 == stack3));
		System.out.println("stack2.equals(stack3) vale " + stack2.equals(stack3));
	}
}

/*
 Marco-Bellias-MacBook-Pro-2:Stack marcob$ javac StackImm2ADTPE.java -d ZcodeE
 Marco-Bellias-MacBook-Pro-2:Stack marcob$ cd ZcodeE
 Marco-Bellias-MacBook-Pro-2:ZcodeE marcob$ java Main
 stack1.top = 5
 stack2.top = 12
 stack2 == stack3 vale false
 stack2.equals(stack3) vale true
 Marco-Bellias-MacBook-Pro-2:ZcodeE marcob$ 
 */

